/*
 * Copyright  2001-2002 Jussi Kivilinna <hullu@unitedadmins.com>
 *
 *    This file is part of cs-rw Metamod Plugin.
 *
 *    I think this file should be is GPL because Metamod is GPL .. but I allow you to
 *    use any part that isn't from Metamod or Valve's HLSDK for whatever you want :)
 */
 
#ifndef CPLAYER_H
#define CPLAYER_H

class CPlayer
{
public:
	bool	m_connected;	//Client connected to this slot
	
	edict_t	*m_pEdict;
	int	m_index;	

	float	m_OldHealth;
	bool 	m_RespawnDetected;

	//Client connected/disconnected
	void PutInServer(edict_t *pThis);
	void Disconnect();
	
	//Player think
	void PostThink();

	bool IsAlive()
	{
		//Not connected -- Not Alive
		if(!m_connected || FNullEnt(m_pEdict)) return false;
		
		return ((m_pEdict->v.deadflag == DEAD_NO) && (m_pEdict->v.health > 0) && !(m_pEdict->v.flags & FL_NOTARGET));
	};
	
	//Get current health
	float CurrentHealth()
	{
		//Not connected -- Not Alive
		if(!m_connected || FNullEnt(m_pEdict)) return -50.0f;
		
		//Dead player .. force neg health
		if(m_pEdict->v.deadflag != DEAD_NO) return -50.0f;
		
		// health from entity
		return m_pEdict->v.health;
	}
	
	//Set return type
	void SetMetaResult(META_RES meta_resu)
	{
		m_message_mres=meta_resu;
	}

	//Get default return type
	META_RES GetMetaResult(void)
	{
		return m_message_mres;
	}

	//Gets index to players array
	static CPlayer *GetPlayerFromArray(int index);
	static CPlayer *GetPlayerFromArray(edict_t *pEnt)
	{
		return GetPlayerFromArray(FNullEnt(pEnt)?0:ENTINDEX(pEnt));
	}
	
	void RemoveWeapons();
	void AddItems(const char *);
	
	const char *GetTeamItems();
	
private:
	META_RES m_message_mres;
};


extern CPlayer players[33];


//Gets pointer to players array with index
inline CPlayer * CPlayer::GetPlayerFromArray(int index)
{
	if(index<1 || index>32) return &players[0];
	return &players[index];
}


#endif /*CPLAYER_H*/
